// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef COMPLETE_PLATFORM_HH
#define COMPLETE_PLATFORM_HH

#include <stdint.h>
#include <systemc>
#include "accelerometer_apb_wrapper.hpp"
#include "actuator.hpp"
#include "amba_apb_bus.hpp"
#include "lfsr_apb_wrapper.hpp"
#include "m6502.hpp"
#include "memory_inst.hpp"
#include "multiplier_apb_wrapper.hpp"
#include "network_interface_apb_wrapper.hpp"
#include "sensor.hpp"
#include "watchdog_apb_wrapper.hpp"

class complete_platform :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > clk;
    sc_core::sc_in< bool > rst;
    sc_core::sc_in< bool > sensor_high;
    sc_core::sc_in< bool > sensor_low;
    sc_core::sc_out< bool > actuator_open;
    sc_core::sc_out< bool > actuator_close;
    sc_core::sc_out< uint16_t > actuator_threshold;
    sc_core::sc_signal< bool > apb_master_pclk;
    sc_core::sc_signal< bool > apb_master_presetn;
    sc_core::sc_signal< uint32_t > apb_master_paddr;
    sc_core::sc_signal< bool > apb_master_psel1;
    sc_core::sc_signal< bool > apb_master_psel2;
    sc_core::sc_signal< bool > apb_master_psel3;
    sc_core::sc_signal< bool > apb_master_psel4;
    sc_core::sc_signal< bool > apb_master_psel5;
    sc_core::sc_signal< bool > apb_master_psel6;
    sc_core::sc_signal< bool > apb_master_psel7;
    sc_core::sc_signal< bool > apb_master_psel8;
    sc_core::sc_signal< bool > apb_master_penable;
    sc_core::sc_signal< bool > apb_master_pwrite;
    sc_core::sc_signal< uint32_t > apb_master_pwdata;
    sc_core::sc_signal< bool > apb_master_pready;
    sc_core::sc_signal< uint32_t > apb_master_prdata;
    sc_core::sc_signal< bool > apb_1_pclk;
    sc_core::sc_signal< bool > apb_1_presetn;
    sc_core::sc_signal< uint32_t > apb_1_paddr;
    sc_core::sc_signal< bool > apb_1_psel;
    sc_core::sc_signal< bool > apb_1_penable;
    sc_core::sc_signal< bool > apb_1_pwrite;
    sc_core::sc_signal< uint32_t > apb_1_pwdata;
    sc_core::sc_signal< bool > apb_1_pready;
    sc_core::sc_signal< uint32_t > apb_1_prdata;
    sc_core::sc_signal< bool > apb_2_pclk;
    sc_core::sc_signal< bool > apb_2_presetn;
    sc_core::sc_signal< uint32_t > apb_2_paddr;
    sc_core::sc_signal< bool > apb_2_psel;
    sc_core::sc_signal< bool > apb_2_penable;
    sc_core::sc_signal< bool > apb_2_pwrite;
    sc_core::sc_signal< uint32_t > apb_2_pwdata;
    sc_core::sc_signal< bool > apb_2_pready;
    sc_core::sc_signal< uint32_t > apb_2_prdata;
    sc_core::sc_signal< bool > apb_3_pclk;
    sc_core::sc_signal< bool > apb_3_presetn;
    sc_core::sc_signal< uint32_t > apb_3_paddr;
    sc_core::sc_signal< bool > apb_3_psel;
    sc_core::sc_signal< bool > apb_3_penable;
    sc_core::sc_signal< bool > apb_3_pwrite;
    sc_core::sc_signal< uint32_t > apb_3_pwdata;
    sc_core::sc_signal< bool > apb_3_pready;
    sc_core::sc_signal< uint32_t > apb_3_prdata;
    sc_core::sc_signal< bool > apb_4_pclk;
    sc_core::sc_signal< bool > apb_4_presetn;
    sc_core::sc_signal< uint32_t > apb_4_paddr;
    sc_core::sc_signal< bool > apb_4_psel;
    sc_core::sc_signal< bool > apb_4_penable;
    sc_core::sc_signal< bool > apb_4_pwrite;
    sc_core::sc_signal< uint32_t > apb_4_pwdata;
    sc_core::sc_signal< bool > apb_4_pready;
    sc_core::sc_signal< uint32_t > apb_4_prdata;
    sc_core::sc_signal< bool > apb_5_pclk;
    sc_core::sc_signal< bool > apb_5_presetn;
    sc_core::sc_signal< uint32_t > apb_5_paddr;
    sc_core::sc_signal< bool > apb_5_psel;
    sc_core::sc_signal< bool > apb_5_penable;
    sc_core::sc_signal< bool > apb_5_pwrite;
    sc_core::sc_signal< uint32_t > apb_5_pwdata;
    sc_core::sc_signal< bool > apb_5_pready;
    sc_core::sc_signal< uint32_t > apb_5_prdata;
    sc_core::sc_signal< bool > apb_6_pclk;
    sc_core::sc_signal< bool > apb_6_presetn;
    sc_core::sc_signal< uint32_t > apb_6_paddr;
    sc_core::sc_signal< bool > apb_6_psel;
    sc_core::sc_signal< bool > apb_6_penable;
    sc_core::sc_signal< bool > apb_6_pwrite;
    sc_core::sc_signal< uint32_t > apb_6_pwdata;
    sc_core::sc_signal< bool > apb_6_pready;
    sc_core::sc_signal< uint32_t > apb_6_prdata;
    sc_core::sc_signal< bool > apb_7_pclk;
    sc_core::sc_signal< bool > apb_7_presetn;
    sc_core::sc_signal< uint32_t > apb_7_paddr;
    sc_core::sc_signal< bool > apb_7_psel;
    sc_core::sc_signal< bool > apb_7_penable;
    sc_core::sc_signal< bool > apb_7_pwrite;
    sc_core::sc_signal< uint32_t > apb_7_pwdata;
    sc_core::sc_signal< bool > apb_7_pready;
    sc_core::sc_signal< uint32_t > apb_7_prdata;
    sc_core::sc_signal< bool > apb_8_pclk;
    sc_core::sc_signal< bool > apb_8_presetn;
    sc_core::sc_signal< uint32_t > apb_8_paddr;
    sc_core::sc_signal< bool > apb_8_psel;
    sc_core::sc_signal< bool > apb_8_penable;
    sc_core::sc_signal< bool > apb_8_pwrite;
    sc_core::sc_signal< uint32_t > apb_8_pwdata;
    sc_core::sc_signal< bool > apb_8_pready;
    sc_core::sc_signal< uint32_t > apb_8_prdata;
    sc_core::sc_signal< uint16_t > addr;
    sc_core::sc_signal< uint8_t > datai;
    sc_core::sc_signal< uint8_t > datao;
    sc_core::sc_signal< bool > oeb;
    sc_core::sc_signal< bool > irq_n;
    sc_core::sc_signal< bool > nmi_n;
    sc_core::sc_signal< bool > res_n;
    sc_core::sc_signal< bool > rdy;
    sc_core::sc_signal< bool > sob_n;
    sc_core::sc_signal< bool > sync;
    sc_core::sc_signal< bool > vpab;
    sc_core::sc_signal< bool > we_n;

    m6502 m6502_0;
    memory_inst memory_0;
    amba_apb_bus amba_apb_bus_0;
    multiplier_apb_wrapper multiplier_0;
    accelerometer_apb_wrapper accelerometer_0;
    network_interface_apb_wrapper network_interface_0;
    lfsr_apb_wrapper lfsr_0;
    sensor sensor_0;
    actuator actuator_0;
    watchdog_apb_wrapper watchdog_0;


    SC_HAS_PROCESS( complete_platform );

    complete_platform( sc_core::sc_module_name name_ );
    ~complete_platform();


private:

    complete_platform( const complete_platform & );
    const complete_platform& operator= ( const complete_platform & );


};


#endif

